<ng-container *transloco="let t; scope: 'admin'; read: 'admin'">
    <div class="user-list">
        <div class="row mb-3">
            <div class="col-md-12">
                <div class="template-demo">
                    <nav aria-label="breadcrumb">
                        <ol class="breadcrumb breadcrumb-custom">
                            <li class="breadcrumb-item"><a routerLink="/{{urlPrefix}}" routerLinkActive="router-link-active">Dashboard</a></li>
                            <li class="breadcrumb-item"><a routerLink="/{{urlPrefix}}/access-controls/roles" routerLinkActive="router-link-active">Role</a></li>
                            <li class="breadcrumb-item active" aria-current="page"><span>All Role</span></li>
                        </ol>
                        
                    </nav>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12 stretch-card">
                <mat-card class="card custom-card">
                    <div class="card-body p-0">
                        <div class="row m-0">
                            <div class="col-md-12 card-title px-3 py-3 m-0 position-relative">
                                <button mat-mini-fab (click)="openSelectColumns()" aria-label="Filter List"
                                    class="btn btn-primary float-start m-0 ms-2 mt-1 bg-btn-primary-gradient">
                                    <mat-icon>fact_check</mat-icon>
                                </button>
                                <mat-select #columnSelect [(ngModel)]="displayedColumns" multiple class="custom-select-dropdown">
                                    <mat-option *ngFor="let col of columns" [value]="col">
                                    <!-- {{t('userSetup.'+col)}} -->
                                    {{col}}
                                    </mat-option>
                                </mat-select>
                                <h4 class="float-start pt-2 px-2 mt-2">All Roles</h4>
                                <button mat-raised-button class="float-end ms-3 btn btn-primary btn-rounded btn-fw" routerLink="/{{urlPrefix}}/access-controls/roles/add-role" routerLinkActive="router-link-active" >+ Add Role</button>
                                <button mat-mini-fab aria-label="Filter List" (click)="isFilter = !isFilter"
                                    class="float-end btn btn-primary m-0 bg-btn-primary-gradient ">
                                    <mat-icon>filter_list</mat-icon>
                                </button>
                            </div>
                        </div>

                        <form action="" class="border-bottom" [formGroup]="filterForm" (ngSubmit)="filterServiceRequest()" *ngIf="isFilter">
                            <div class="row p-3 pb-0" *ngIf="isFilter">
                                <div class="col-4 pb-0">
                                    <mat-form-field class="w-100">
                                        <mat-label>Code</mat-label>
                                        <input matInput placeholder="Enter Code" formControlName="code">
                                    </mat-form-field>
                                </div>
                                <div class="col-4 pb-0">
                                    <button mat-raised-button color="primary" aria-label="Add user" [class.btn-disabled]="filterForm.invalid" [disabled]="filterForm.invalid"
                                        class="btn btn-primary bg-btn-info-gradient me-3">
                                        Search
                                    </button>
                                    <button mat-raised-button color="primary" aria-label="Add user" type="reset"
                                        class="btn btn-secondary bg-btn-secondary-gradient me-3" (click)="resetFilter()">
                                        Reset
                                    </button>
                                </div>
                            </div>
                        </form>

                        <div class="row m-0">
                            <div class="col-12 card-max">
                                <table mat-table [dataSource]="dataSource" class="w-100">

                                    <!-- Name Column -->
                                    <ng-container matColumnDef="name">
                                        <th mat-header-cell *matHeaderCellDef> Name </th>
                                        <td mat-cell *matCellDef="let element">
                                            <p class="py-1 m-0" *ngIf="t('lang') == 'en'">{{jsonParse(element.name)['name_'+t('lang')]}} ({{jsonParse(element.name)['name_hi']}})</p>
                                            <p class="py-1 m-0" *ngIf="t('lang') == 'hi'">{{jsonParse(element.name)['name_'+t('lang')]}} ({{jsonParse(element.name)['name_en']}})</p>
                                        </td>
                                    </ng-container>

                                    <!-- Weight Column -->
                                    <ng-container matColumnDef="code">
                                        <th mat-header-cell *matHeaderCellDef> Code </th>
                                        <td mat-cell *matCellDef="let element" class="">
                                            {{element.code}}
                                        </td>
                                    </ng-container>

                                    <!-- Symbol status -->
                                    <ng-container matColumnDef="status">
                                        <th mat-header-cell *matHeaderCellDef> Status </th>
                                        <td mat-cell *matCellDef="let element">
                                            <span class="badge bg-success border-radius-round"
                                                *ngIf="element.isActive">Active</span>
                                            <span class="badge bg-danger border-radius-round"
                                                *ngIf="!element.isActive">Inactive</span>
                                        </td>
                                    </ng-container>

                                    <!-- Symbol dateCreated -->
                                    <ng-container matColumnDef="dateCreated">
                                        <th mat-header-cell *matHeaderCellDef> Date Created </th>
                                        <td mat-cell *matCellDef="let element"> {{element.createdAt | date:'medium'}} </td>
                                    </ng-container>
                                    <!-- Symbol action -->
                                    <ng-container matColumnDef="active">
                                        <th mat-header-cell *matHeaderCellDef>  </th>
                                        <td mat-cell *matCellDef="let element">
                                            <mat-slide-toggle class="my-slide-toggle" [(ngModel)]="element.isActive" (change)="updateStatus(element)">
                                            </mat-slide-toggle>
                                        </td>
                                    </ng-container>

                                    <!-- Symbol action -->
                                    <ng-container matColumnDef="action">
                                        <th mat-header-cell *matHeaderCellDef class="text-end"> Action </th>
                                        <td mat-cell *matCellDef="let element">
                                            <button mat-mini-fab aria-label="Filter List" (click)="editRoleDetails(element.id)"
                                                class="float-end btn btn-primary m-0 bg-btn-primary-gradient ">
                                                <mat-icon>edit</mat-icon>
                                            </button>
                                        </td>
                                    </ng-container>

                                    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                                    <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
                                </table>
                            </div>
                            <div class="col-12">
                                <mat-paginator [length]="dataSource.totalDataLength.value" [pageSize]="10" [pageSizeOptions]="[5, 10, 20]" showFirstLastButtons></mat-paginator>
                            </div>
                        </div>
                        
                    </div>
                </mat-card>
            </div>
        </div>
    </div>
</ng-container>